Skip to content

Build the Git source of a blue/green deployment now

POST
/api/docker/nodes/{nodeId}/deployments/{deploymentId}/source/builds
curl --request POST \
--url https://opfield.example.com/api/docker/nodes/550e8400-e29b-41d4-a716-446655440000/deployments/550e8400-e29b-41d4-a716-446655440000/source/builds \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '{ "commitSha": "example", "force": false }'

Queues a manual build of the desired commit (commitSha must name it when given; force builds again even when an artifact of the commit exists). Answers 201 with the new build, or 200 with the build that already covers the commit. Requires docker:containers:manage on the deployment.

nodeId
required
string
>= 1 characters
Example
550e8400-e29b-41d4-a716-446655440000
deploymentId
required
string
>= 1 characters
Example
550e8400-e29b-41d4-a716-446655440000

Optional JSON request body

Media typeapplication/json
object
commitSha
string
/^[0-9a-f]{40,64}$/
force
boolean

Successful response

Media typeapplication/json
object
data
required

Resource object. Exact fields depend on the endpoint.

object
id
string
name
string
key
additional properties
Example
{
"data": {
"id": "550e8400-e29b-41d4-a716-446655440000",
"name": "Example resource",
"createdAt": "2024-01-01T12:00:00.000Z",
"updatedAt": "2024-01-01T12:30:00.000Z"
}
}

Created

Media typeapplication/json
object
data
required

Resource object. Exact fields depend on the endpoint.

object
id
string
name
string
key
additional properties
Example
{
"data": {
"id": "550e8400-e29b-41d4-a716-446655440000",
"name": "Example resource",
"createdAt": "2024-01-01T12:00:00.000Z",
"updatedAt": "2024-01-01T12:30:00.000Z"
}
}

Bad request

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "VALIDATION_ERROR",
"message": "Request validation failed",
"details": [
{
"path": [
"name"
],
"message": "Required"
}
]
}

Authentication required

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "UNAUTHORIZED",
"message": "Authentication required"
}

Forbidden

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "FORBIDDEN",
"message": "Insufficient permissions"
}

Not found

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "NOT_FOUND",
"message": "Resource not found"
}

Conflict

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "CONFLICT",
"message": "Resource already exists"
}

Unprocessable entity

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "UNPROCESSABLE_ENTITY",
"message": "Request could not be processed"
}

Internal server error

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "INTERNAL_ERROR",
"message": "Internal server error"
}

The build is not admitted: BUILD_WORKERS_PAUSED (“All Build Workers are paused for new builds”), NO_BUILD_WORKER_AVAILABLE, BUILD_SCHEDULER_UNAVAILABLE, or INTERNAL_REGISTRY_NOT_WRITABLE (the internal registry takes no pushes: its disk is 90% full or more, or it is in maintenance).

Media typeapplication/json
object
code
required

Error code

string
message
required

Human-readable error message

string
details

Additional error details

Example
{
"code": "VALIDATION_ERROR",
"message": "Request validation failed"
}